module presspb_led_nios2(
	input wire	CLK,
	input wire	CLR,
	input wire	PB,
	output wire	LED
	);

wire	wire_led;


nios2_system nios2 (
	.clk_clk							(CLK), 
	.reset_reset_n 					(CLR), 
 	.pb_pio_external_connection_export	(~PB),
	.led_pio_external_connection_export	 (wire_led)
	);

assign	LED = ~wire_led;

endmodule
